=== debian/changelog ===
linglong-box (1.3.4-1) unstable; urgency=medium

  * update version;
  * fix some bugs.

 -- Chen Linxuan <me@black-desk.cn>  Wed, 03 Jan 2024 17:06:55 +0800

linglong-box (1.3.3.15-1) unstable; urgency=medium

  * update version.

 -- huqinghong <huqinghong@uniontech.com>  Tue, 27 Dec 2022 14:54:52 +0800

linglong-box (1.3.3.14-1) unstable; urgency=medium

  * update version.

 -- yuanqiliang <yuanqiliang@uniontech.com>  Thu, 25 Nov 2022 11:02:00 +0800

linglong-box (1.3.3.13-1) unstable; urgency=medium

  * update version.

 -- Chen Linxuan <chenlinxuan@uniontech.com>  Thu, 24 Nov 2022 11:02:00 +0800

linglong-box (1.3.3.12-1) unstable; urgency=medium

  * update version.

 -- Chen Linxuan <chenlinxuan@uniontech.com>  Thu, 27 Oct 2022 14:58:00 +0800

linglong-box (1.3.3.11-1) unstable; urgency=medium

  * update version to 1.3.3.11-1 for deepin.

 -- huqinghong <huqinghong@uniontech.com>  Wed, 26 Oct 2022 15:33:06 +0800

linglong-box (1.3.3.10-1) unstable; urgency=medium

  * update version.

 -- chenhuixing <chenhuixing@uniontech.com>  Fri, 23 Sep 2022 11:19:11 +0800

linglong-box (1.3.3.9-1) unstable; urgency=medium

  * update version.

 -- chenlinxuan <chenlinxuan@uniontech.com>  Thu, 22 Sep 2022 11:09:15 +0800

linglong-box (1.3.3.7-1) unstable; urgency=medium

  * update version.

 -- chenhuixing <chenhuixing@uniontech.com>  Tue, 06 Sep 2022 10:58:15 +0800

linglong-box (1.3.3.5-1) unstable; urgency=medium

  * update version to 1.3.3.5-1 for deepin.

 -- liujianqiang <liujianqiang@uniontech.com>  Mon, 01 Aug 2022 20:50:57 +0800

linglong-box (1.3.3-1) unstable; urgency=medium

  * update version to 1.3.3-1 for deepin.

 -- liujianqiang <liujianqiang@uniontech.com>  Thu, 28 Jul 2022 15:29:46 +0800

linglong-box (1.3.2-1) unstable; urgency=medium

  * update version.

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 24 Jun 2022 16:56:42 +0800

linglong-box (1.3.0-1) unstable; urgency=medium

  * update version.

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 27 May 2022 17:45:46 +0800

linglong-box (1.2.7-1) unstable; urgency=medium

  * fix build issue.

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 15 Apr 2022 18:33:27 +0800

linglong-box (1.2.6-1) unstable; urgency=medium

  * 1. adjust wait pid strategy.
  * 2. print pidns in log.
  * 3. configure uid/gid mapping after clone.
  * 4. remove CLONE-FS flag when cloning NonePrivilegeProc.
  * 5. wrong /dev/ptmx link.

 -- liujianqiang <liujianqiang@uniontech.com>  Tue, 22 Mar 2022 13:38:53 +0800

linglong-box (1.2.5-1) unstable; urgency=medium

  * 1. rename json fields.
  * 2. close leaked fds.
  * 3. remove forced CLONE_NEWPID flag for second clone.
  * 4. add waitpid helper.
  * 5. add support for dbus proxy.
  * 6. remove unused code.

 -- liujianqiang <liujianqiang@uniontech.com>  Tue, 15 Mar 2022 10:04:16 +0800

linglong-box (1.2.4-1) unstable; urgency=medium

  * 1. void c_str() of destoryed string

 -- chenlinxuan <chenlinxuan@uniontech.com>  Tue, 08 Mar 2022 13:27:24 +0800

linglong-box (1.2.3-1) unstable; urgency=medium

  * 1. make fuse-overlayfs defalut.
  * 2. fix update error info.
  * 3. fix do mount by proc fd.

 -- liujianqiang <liujianqiang@uniontech.com>  Tue, 08 Mar 2022 13:27:24 +0800

linglong-box (1.2.2-1) unstable; urgency=medium

  * 1. fix read/write /dev/null failed.
  * 2. add log fliter.
  * 3. fix mount mqueue amd cgroup in rootless mode.
  * 4. fix make mountnode const again.
  * 5. fix make ro bind work.

 -- liujianqiang <liujianqiang@uniontech.com>  Wed, 16 Feb 2022 13:47:58 +0800

linglong-box (1.2.1-1) unstable; urgency=medium

  *  1. fuse proxy support
  *  2. fix construct string with nullptr cause crash
  *  3. fallback to bind when sysfs mount failed
  *  4. root mount for ll-fuse-proxy

 -- liujianqiang <liujianqiang@uniontech.com>  Mon, 24 Jan 2022 08:55:58 +0800

linglong-box (1.2.0-1) unstable; urgency=medium

  *  mount add a MS_REC flag

 -- liujianqiang <liujianqiang@uniontech.com>  Fri, 14 Jan 2022 10:51:13 +0800

linglong-box (1.0.1-1) unstable; urgency=medium

  * support rootless and fuse

 -- iceyer <me@iceyer.net>  Wed, 29 Dec 2021 17:57:01 +0800

linglong-box (1.0-1) unstable; urgency=medium

  * Init package.

 -- chenhuixing <chenhuixing@uniontech.com>  Thu, 09 Sep 2021 11:41:48 +0000
