=== debian/control ===
Source: linglong-box
Section: admin
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends:
 debhelper (>= 11),
 cmake,
 libyaml-cpp-dev,
 pkg-config,
 libseccomp-dev,
 libgtest-dev
Standards-Version: 4.1.3
Homepage: https://www.deepin.org

Package: linglong-box
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Deepin sandbox with OCI standard.
 Deepin sandbox...
