=== debian/changelog ===
linglong-box (2.0.0-1) unstable; urgency=medium

  * release 1.8.1-1.

 -- dengbo <dengbo@deepin.org>  Thu, 10 Apr 2025 13:45:47 +0800
