## linglong-box 2.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(
   linyaps-box
-  VERSION 2.0.0
+  VERSION 2.0.3
   DESCRIPTION "A simple OCI runtime for desktop applications"
   HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps-box"
   LANGUAGES CXX)
@@ -38,6 +38,8 @@
        ${linyaps-box_IS_TOP_LEVEL})
 
 option(linyaps-box_ENABLE_SMOKE_TESTS "Enable smoke tests." OFF)
+
+option(linyaps-box_MAKE_RELEASE "Make release build." OFF)
 
 if(linyaps-box_ENABLE_SMOKE_TESTS OR linyaps-box_ENABLE_UNIT_TESTS)
   set(linyaps-box_ENABLE_TESTING ON)
@@ -179,10 +181,26 @@
     src/linyaps_box/utils/semver.h
     src/linyaps_box/utils/socketpair.cpp
     src/linyaps_box/utils/socketpair.h
+    src/linyaps_box/utils/symlink.cpp
+    src/linyaps_box/utils/symlink.h
     src/linyaps_box/utils/touch.cpp
     src/linyaps_box/utils/touch.h)
 
 set(LINYAPS_BOX_VERSION ${PROJECT_VERSION})
+
+if(NOT linyaps-box_MAKE_RELEASE)
+  message(STATUS "make dev build")
+
+  execute_process(
+    COMMAND git rev-parse --short=7 HEAD
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+    OUTPUT_VARIABLE GIT_COMMIT_HASH
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+  )
+
+  set(LINYAPS_BOX_VERSION "${LINYAPS_BOX_VERSION}-dev-${GIT_COMMIT_HASH}")
+endif()
+
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/linyaps_box/version.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/src/linyaps_box/version.h @ONLY)
 
@@ -222,7 +240,7 @@
     NAME CLI11
     VERSION 2.4.1
     GITHUB_REPOSITORY CLIUtils/CLI11
-    GIT_TAG v2.4.1
+    GIT_TAG v2.5.0
     EXCLUDE_FROM_ALL ON
     OPTIONS "CLI11_BUILD_TESTS OFF")
 endif()
@@ -326,15 +344,3 @@
 target_compile_features("${linyaps-box_APP}" PRIVATE cxx_std_17)
 set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD 17)
 set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_EXTENSIONS OFF)
-set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD_REQUIRED ON)
-target_compile_definitions(
-  "${linyaps-box_APP}"
-  PRIVATE "LINYAPS_BOX_DEFAULT_LOG_LEVEL=${linyaps-box_DEFAULT_LOG_LEVEL}"
-  PRIVATE "LINYAPS_BOX_ACTIVE_LOG_LEVEL=${linyaps-box_AVTIVE_LOG_LEVEL}")
-target_compile_options("${linyaps-box_APP}"
-                       PRIVATE -fmacro-prefix-map=${CMAKE_CURRENT_SOURCE_DIR}=.)
-
-# ==============================================================================
-
-include(GNUInstallDirs)
-
