=== debian/changelog ===
linglong-box (2.0.3-1) unstable; urgency=medium

  * release 2.0.3-1.

 -- dengbo <dengbo@deepin.org>  Thu, 17 Jul 2025 21:57:45 +0800

linglong-box (2.0.2-1) unstable; urgency=medium

  * release 2.0.2-1.

 -- dengbo <dengbo@deepin.org>  Wed, 16 Jul 2025 15:21:14 +0800

linglong-box (1.8.1-1) unstable; urgency=medium

  * release 1.8.1-1.

 -- dengbo <dengbo@deepin.org>  Thu, 10 Apr 2025 13:45:47 +0800
