=== debian/control ===
--- 
+++ 
@@ -5,10 +5,12 @@
 Build-Depends:
  debhelper (>= 11),
  cmake,
- libyaml-cpp-dev,
+ libcli11-dev (>= 2.4.1) | hello,
  pkg-config,
  libseccomp-dev,
- libgtest-dev
+ nlohmann-json3-dev (>= 3.5.0) | hello,
+ libgtest-dev,
+ libcap-dev
 Standards-Version: 4.1.3
 Homepage: https://www.deepin.org
