## linglong-box 2.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(
   linyaps-box
-  VERSION 2.1.0
+  VERSION 2.1.3
   DESCRIPTION "A simple OCI runtime for desktop applications"
   HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps-box"
   LANGUAGES CXX)
@@ -94,6 +94,12 @@
     OFF
     CACHE BOOL "enable CPM")
 
+set(linyaps-box_HARDENING
+    ON
+    CACHE BOOL "enable hardening")
+
+set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+
 if(CMAKE_VERSION VERSION_LESS "3.14")
   set(linyaps-box_ENABLE_CPM OFF)
   message(
@@ -106,6 +112,17 @@
     CACHE BOOL "use local packages only")
 
 # ==============================================================================
+
+if (linyaps-box_HARDENING)
+  message(STATUS "applying harden settings")
+  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie -Wl,-z,relro -Wl,-z,now")
+  add_compile_options(-fstack-protector-strong)
+
+  if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
+    message(STATUS "Non-Debug build, enabling FORTIFY_SOURCE")
+    add_compile_definitions(_FORTIFY_SOURCE=2)
+  endif()
+endif()
 
 set(linyaps-box_LIBRARY linyaps-box)
 set(linyaps-box_LIBRARY_SOURCE
@@ -238,11 +255,12 @@
     NAME CLI11
     VERSION 2.5.0
     GITHUB_REPOSITORY CLIUtils/CLI11
-    GIT_TAG v2.5.0
+    GIT_TAG v2.6.1
     EXCLUDE_FROM_ALL ON
     OPTIONS "CLI11_BUILD_TESTS OFF")
 endif()
 
+# find minimal version
 find_package(nlohmann_json 3.11.3 QUIET)
 if(NOT nlohmann_json_FOUND)
   add_subdirectory(external/nlohmann_json)
@@ -333,12 +351,3 @@
 
 add_executable("${linyaps-box_APP}" ${linyaps-box_APP_SOURCE})
 target_include_directories("${linyaps-box_APP}"
-                           ${linyaps-box_APP_SOURCE_INCLUDE_DIRS})
-target_link_libraries("${linyaps-box_APP}" ${linyaps-box_APP_LINK_LIBRARIES})
-if(linyaps-box_STATIC)
-  target_link_options("${linyaps-box_APP}" PRIVATE -static -static-libgcc
-                      -static-libstdc++)
-endif()
-target_compile_features("${linyaps-box_APP}" PRIVATE cxx_std_17)
-set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_STANDARD 17)
-set_property(TARGET "${linyaps-box_APP}" PROPERTY CXX_EXTENSIONS OFF)
